#include <windows.h>
#include <string.h>

#define LAPDISP	2
#define DISP	3
#define START	4
#define STOP	5
#define LAP	6
#define RESET	7
#define END	8

#define TIMEREVENT	1

static unsigned NowTime;
static DWORD LastClock;
static int CountUp;

TCHAR *MkTimeStr(unsigned time, int UseMsec)
{ // ͌\蔲ł (^^;
	static TCHAR ret[64];
	unsigned hour, min, sec, dsec, msec;
	msec = time % 100;
	time /= 100;
	dsec = time % 10;
	time /= 10;
	sec = time % 60;
	time /= 60;
	min = time % 60;
	time /= 60;
	hour = time;
	if (UseMsec)
		wsprintf(ret, "%4d:%02d:%02d.%1d%02d ", hour, min, sec, dsec, msec);
	else
		wsprintf(ret, "%4d:%02d:%02d.%1d   ", hour, min, sec, dsec, msec);
	return ret;
}

LRESULT CALLBACK DispProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp)
{ // ԕ\pR[obN
	static HDC hdc, bdc;
	static RECT rct;
	static HBITMAP bmap;
	PAINTSTRUCT ps;
	static HFONT hFont, OldFont;
	TCHAR *str;

	switch (msg) {

	case WM_TIMER: // ^C}[CxgA
		switch (wp) {

		case TIMEREVENT:
			timeBeginPeriod(1);
			{ //  auto ϐĂ邽߂ɁAt
				static unsigned lastclock;
				DWORD tmp = timeGetTime();
				timeEndPeriod(1);
				NowTime += tmp - LastClock;
				LastClock = tmp;
				if (lastclock != NowTime/100) {
					// \ύX̂Ƃ (0.1 b)
					lastclock = NowTime / 100;
					InvalidateRect(hWnd, NULL, FALSE);
				}
			}
		default:
			break;
		}
		break;

	case WM_CREATE: // ʍ쐬AtHg̕ύX
		hdc = GetDC(hWnd);
		bdc = CreateCompatibleDC(hdc);
		GetClientRect(hWnd, &rct);
		bmap = CreateCompatibleBitmap(hdc, rct.right, rct.bottom);
		SelectObject(bdc, bmap);
		hFont = CreateFont(48, 24, 0, 0, FW_SEMIBOLD, FALSE, FALSE,
				   FALSE, ANSI_CHARSET, OUT_DEFAULT_PRECIS,
				   CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
				   FIXED_PITCH | FF_DONTCARE, ""); // ANSI 
		if (hFont == NULL) { // G[`FbN ԂʂȂ͂B
			MessageBox(hWnd, "tHg ł܂",
				   "mF", MB_YESNO | MB_ICONQUESTION);
			DestroyWindow(hWnd);
		}
		OldFont = (HFONT) SelectObject(bdc, hFont);
		if (OldFont == NULL) { // G[`FbN ԂʂȂ͂B
			MessageBox(hWnd, "tHg ł܂",
				   "mF", MB_YESNO | MB_ICONQUESTION);
			DestroyWindow(hWnd);
		}
		break;

	case WM_DESTROY:
		ReleaseDC(hWnd, hdc);
		SelectObject(hdc, OldFont);
		DeleteObject(hFont);
		DeleteDC(bdc);
		DeleteObject(bmap);
		PostQuitMessage(0);
		break;


	case WM_PAINT: // \ ʎgp
		str = MkTimeStr(NowTime, !CountUp);
		TextOut(bdc, rct.top, rct.left, str, strlen(str));
		BeginPaint(hWnd, &ps);
		BitBlt(ps.hdc,
		       ps.rcPaint.left,
		       ps.rcPaint.top,
		       ps.rcPaint.right - ps.rcPaint.left,
		       ps.rcPaint.bottom - ps.rcPaint.top,
		       bdc, ps.rcPaint.left, ps.rcPaint.top, SRCCOPY);
		EndPaint(hWnd, &ps);
		break;

	default:
		return DefWindowProc(hWnd, msg, wp, lp);
	}
	return 0;
}

LRESULT CALLBACK LapProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp)
{
	switch (msg) {
		HDC hdc;
		RECT rctSize;
		PAINTSTRUCT ps;

	case WM_PAINT:
		GetClientRect(hWnd, &rctSize);
		hdc = BeginPaint(hWnd, &ps);
		DrawText(hdc, TEXT(MkTimeStr(NowTime, 1)), -1, &rctSize, DT_LEFT);
		EndPaint(hWnd, &ps);
		break;

	case WM_CLOSE:
		DestroyWindow(hWnd);
		break;

	default:
		return DefWindowProc(hWnd, msg, wp, lp);
	}
	return 0;
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp)
{
	HDC hdc;
	PAINTSTRUCT ps;
	CREATESTRUCT *lpcs;
	static HINSTANCE hInstance;

	static HWND bWnd[10];

	switch (msg) {
		int itmp;
		HWND dWnd;
		WNDCLASS winc;

	case WM_CREATE:
		lpcs = (CREATESTRUCT *) lp;
		hInstance = lpcs->hInstance;
// ԕ\@ECh[
		winc.style = CS_HREDRAW | CS_VREDRAW;
		winc.lpfnWndProc = DispProc;
		winc.cbClsExtra = winc.cbWndExtra = 0;
		winc.hInstance = hInstance;
		winc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
		winc.hCursor = LoadCursor(NULL, IDC_ARROW);
		winc.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);
		winc.lpszMenuName = NULL;
		winc.lpszClassName = TEXT("DISP");

		if (!RegisterClass(&winc)) {
			MessageBox(hWnd, "DISP Window ł܂",
				   "mF", MB_YESNO | MB_ICONQUESTION);
			DestroyWindow(hWnd);
		}
// bv^CpECh[ݒiύX̂݁j
		winc.lpfnWndProc = LapProc;
		winc.lpszClassName = TEXT("LAP");

		if (!RegisterClass(&winc)) {
			MessageBox(hWnd, "LAP Window ł܂",
				   "mF", MB_YESNO | MB_ICONQUESTION);
			DestroyWindow(hWnd);
		}

// ECh[ 
		bWnd[DISP] = CreateWindow(TEXT("DISP"), TEXT("Push Start Button"),
				WS_CHILD | WS_VISIBLE, 0, 0, 380, 47,
				hWnd, (HMENU) DISP, hInstance, NULL);

		bWnd[START] = CreateWindow(TEXT("BUTTON"), TEXT("Start"),
				WS_CHILD | BS_DEFPUSHBUTTON, 30, 48, 100, 48,
				hWnd, (HMENU) START, hInstance, NULL);

		bWnd[STOP] = CreateWindow(TEXT("BUTTON"), TEXT("Stop"),
				WS_CHILD | BS_DEFPUSHBUTTON, 30, 48, 100, 48,
				hWnd, (HMENU) STOP, hInstance, NULL);

		bWnd[LAP] = CreateWindow(TEXT("BUTTON"), TEXT("Lap"),
				WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON, 150, 48, 100, 48,
				hWnd, (HMENU) LAP, hInstance, NULL);

		bWnd[RESET] = CreateWindow(TEXT("BUTTON"), TEXT("Reset"),
				WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON, 270, 48, 100, 48,
				hWnd, (HMENU) RESET, hInstance, NULL);

		for (itmp = DISP; itmp <= RESET; itmp++) {
			if (bWnd[itmp] == NULL) {
				MessageBox(hWnd, "Window ł܂", "mF",
					MB_YESNO | MB_ICONQUESTION);
				DestroyWindow(hWnd);
			}
		}

		ShowWindow(bWnd[START], SW_SHOW); // Start,Stop ͍ŏ͔\Ȃ̂

		break;

	case WM_DESTROY:
		KillTimer(hWnd, TIMEREVENT); // ǂ킩Ȃ̂łƂ肠~߂ĂB
		PostQuitMessage(0);
		break;

	case WM_COMMAND:
		switch (LOWORD(wp)) {

		case START:
			CountUp = 1; // Ă邩ǂ̃tO
			timeBeginPeriod(1);
			LastClock = timeGetTime();
			timeEndPeriod(1);
			ShowWindow(bWnd[START], SW_HIDE);
			ShowWindow(bWnd[STOP], SW_SHOW);
			SetTimer(bWnd[DISP], TIMEREVENT, 0, NULL); // ^C}[X^[g
			break;

		case STOP:
			CountUp = 0; // Ă邩ǂ̃tO
			timeBeginPeriod(1);
			NowTime += timeGetTime() - LastClock;
			timeEndPeriod(1);
			ShowWindow(bWnd[STOP], SW_HIDE);
			ShowWindow(bWnd[START], SW_SHOW);
			KillTimer(bWnd[DISP], TIMEREVENT); // ^C}[Xgbv
			break;

		case LAP:
			if (CountUp) { // JEgAbvĂƂAƂ肠(^^;
				timeBeginPeriod(1);
				NowTime += timeGetTime() - LastClock;
				timeEndPeriod(1);
			}
			{ // ꉞAgȂ auto ϐ܂Ƃ߂
				static unsigned i; // \ʒuLp
				HWND lWnd; 
				RECT rct;
				GetWindowRect(hWnd, &rct);
				lWnd = CreateWindow(TEXT("LAP"), TEXT("LapTime"),
						WS_VISIBLE | WS_SYSMENU,
						rct.left + i * 40, rct.top + 135 + (i % 3) * 60,
						120, 60, hWnd, NULL, hInstance, NULL);
				i = i < 7 ? i + 1 : 0;
				if (lWnd == NULL) {
					MessageBox(hWnd,
						"Window ł܂", "mF",
						MB_YESNO | MB_ICONQUESTION);
					DestroyWindow(lWnd);
				}
			}

			return 0;

		case RESET:
			NowTime = 0;
			break;

		default:
			break;
		}
		InvalidateRect(hWnd, NULL, FALSE);
		break;

	default:
		return DefWindowProc(hWnd, msg, wp, lp);
	}
	return 0;
}

int WINAPI
WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
	PSTR lpCmdLine, int nCmdShow)
{
	HWND hWnd;
	MSG msg;
	WNDCLASS winc;

	winc.style = CS_HREDRAW | CS_VREDRAW;
	winc.lpfnWndProc = WndProc;
	winc.cbClsExtra = winc.cbWndExtra = 0;
	winc.hInstance = hInstance;
	winc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	winc.hCursor = LoadCursor(NULL, IDC_ARROW);
	winc.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);
	winc.lpszMenuName = NULL;
	winc.lpszClassName = TEXT("BASE");

	if (!RegisterClass(&winc))
		return -1;

	hWnd = CreateWindow(TEXT("BASE"), TEXT("StopWatch"),
			    WS_VISIBLE | WS_SYSMENU,
			    CW_USEDEFAULT, CW_USEDEFAULT, 400, 130,
			    NULL, NULL, hInstance, NULL);

	if (hWnd == NULL)
		return -1;

// ͎蔲ł@(^^;
	while (GetMessage(&msg, NULL, 0, 0))
		DispatchMessage(&msg);

	return msg.wParam;
}
